<?
#################################################################################
#
# WebGrab Version 1.0
# Autor:	Michael Brauchl
# Datum:  31.12.2001
# Lizenz: GPL
#
#################################################################################


### User Authentifizierung mittels Cookie #######################################
#
# Hat der User keine Cookies eingestellt, wird bei jedem Aufruf einer Seite 
# erneut eine Session geffnet. Damit erhlt der Zielhost auch keine Cookies 
# zurckgeliefert.
#
#################################################################################

if (!isset($HTTP_COOKIE_VARS['webgrab_user']))
	$webgrab_user = md5(uniqid(rand()));
else
	$webgrab_user = $HTTP_COOKIE_VARS['webgrab_user'];
	
//setcookie ("webgrab_user", $webgrab_user, "time()+86400","/", "test.phpcms.de", 0);
$time = mktime()+31449600; 
$date = date("l, d-M-y H:i:s", ($time)); 
header("Set-Cookie: webgrab_user=$webgrab_user; expires=$date GMT;/;$SERVER_NAME;0");

### Decoder fr http 1.1 ########################################################
#
# Das etwas schneller Protokoll HTTP 1.1 liefert die Daten in einzelnen 
# "Stcken". Das hat den Vorteil, dass die Paketgre optimiert ist, aber auch 
# den Nachteil, dass man sich um das wieder zusammensetzen kmmern mu.
#
#################################################################################

function Decode_Chunked_Message($message) {

	$DEBUG=FALSE;
	$CRLF_LENGHT = 2;	
	$chunk_pos=0;
	$crlf_pos = strpos ($message , "\r\n" , $chunk_pos);
	$chunk_size=trim(substr($message,$chunk_pos,$crlf_pos));
	$octets_to_read = hexdec($chunk_size);
	$start_read = $crlf_pos + $CRLF_LENGHT;
	$buffer='';

	while($octets_to_read>0)
		{
		if($DEBUG) 
			{
			echo "chunk_pos : $chunk_pos<br>
			crlf_pos : $crlf_pos<br>
			octets_to_read : $octets_to_read ($chunk_size)<br>
			start_read : $start_read<br><br><br>";
			}
		$buffer.=substr($message,$start_read,$octets_to_read);

		if($DEBUG) 
			{
			echo "Buffer size:".strlen($buffer)."<br>";
			echo "Buffer content:".htmlentities(substr($message,$start_read,$octets_to_read))."<br>";
			}

		$chunk_pos = $start_read + $octets_to_read + $CRLF_LENGHT;

		if(strlen($message)>$chunk_pos) 
			{
			$crlf_pos = @strpos ($message , "\r\n" , $chunk_pos);

			$chunk_size=trim(substr($message,$chunk_pos,$crlf_pos-$chunk_pos));
			$octets_to_read = hexdec($chunk_size);
			$start_read = $crlf_pos + $CRLF_LENGHT;
			} 
		else 
			$octets_to_read=0;
		} 
	return $buffer;
	}

### Verwaltung von Cookies ######################################################
#
# Wenn eine Website ein Cookie setzt, mu das abgelegt werden, um es beim 
# nchsten Besuch der Seite dem Server zu liefern.
#
# Diese Klasse wird noch ausgebaut. Was noch nicht implementiert ist: Lschen von
# alten Cookies und Behandlung von Pfaden. Das sollte aber kein Problem
# darstellen.
#
#################################################################################

class cookie_container
	{
	# wenn vorhanden, cookiefile lesen
	function cookie_container()
		{
		global $webgrab_user;

		$temp_buffer = @file(dirname(__FILE__).'/cookies/'.$webgrab_user.'.txt');

		# Daten aufbereiten
		$temp_buffer = stripslashes($temp_buffer[0]);
		$this->$webgrab_user = unserialize ($temp_buffer);
		}

	# Domainnamen fr den Hash encodieren
	function encode_domainname($domain_name)
		{
		$save_name = substr($domain_name,1);
		$save_name = str_replace ('.','_DOT_',$save_name);
		return $save_name;
		}

	# speichert ein cookie im container	
	function put_cookie($cookie)
		{
		global $url;
		global $webgrab_user;

		# namen von Parametern trennen
		if (strstr($cookie,';'))
			{
			$value_pair   = trim(substr($cookie, 0, strpos($cookie, ';')));
			$cookie_parms = substr($cookie, strpos($cookie, ';')+1);
			$parms = explode(';',$cookie_parms);
			foreach ($parms as $parm)
				{
				list($k,$v)=explode('=',$parm);
				$temp->$k = $v;
				}
			}
		else
			{
			$value_pair = trim($cookie);
			}

		$temp->name  = trim(substr($value_pair,0,strpos($value_pair,'=')));
		$temp->value = trim(substr($value_pair,strpos($value_pair,'=')+1));

		$save_name = $this->encode_domainname('.'.$url['domain']);

		while(list($k, $v) = each($temp))
			{
			$this->$webgrab_user->domain[$save_name][$temp->name][$k]=$v;
			}

		unset ($temp);
		}

	function save()
		{
		global $webgrab_user;

		$towrite = serialize ($this->$webgrab_user);
		addslashes ($towrite);
		$fp = fopen(dirname(__FILE__).'/cookies/'.$webgrab_user.'.txt', 'wb');
		fwrite ($fp,$towrite, strlen($towrite));
		fclose($fp);
		}

	function send_cookie()
		{
		global $url;
		global $webgrab_user;

		$domain = $this->encode_domainname('.'.$url['domain']);
		
		if (!isset($this->$webgrab_user->domain[$domain]))
			return false;

		$RetVal = 'Cookie: ';	
		foreach ($this->$webgrab_user->domain[$domain] as $cookie)
			{
				$RetVal.= trim($cookie['name']).'='.trim($cookie['value']).'; ';
			}
		$RetVal = substr($RetVal,0,-2)."\r\n";
		return $RetVal;
		}
	}

### Ein Formular zum Server senden ##############################################
#
# Diese Funktion sendet die Daten, die zuerst an das Skript WebGrab gepostet
# wurden an den Server. Es wird dabei ein Browser und die Funktion POST
# simuliert.
#
#################################################################################

function PostToHost( $host, $path, $data_to_send, $referer ) 
	{
	global $HTTP_USER_AGENT;
	global $HTTP_ACCEPT;
	global $HTTP_ACCEPT_LANGUAGE;	
	global $cookie_container;
	global $http_header;
  $cRetVal = "";
	
  $fp = fsockopen( $host, 80, $errno, $errstr, 30 );

	if (!$fp)
		{
		echo "Host: $host not aviable now!<br>\n";
		echo "Error: $errstr ($errno)<br>\n";
		exit;
		}

  fputs( $fp, "POST $path HTTP/1.1\r\n" );
  fputs( $fp, "Host: $host\r\n" );
  if ($cookie = $cookie_container->send_cookie())
  	{
  	fputs( $fp, $cookie );  
  	}
  fputs( $fp, "Accept: $HTTP_ACCEPT\r\n");
  fputs( $fp, "Accept-Language: $HTTP_ACCEPT_LANGUAGE\r\n");  
  fputs( $fp, "User-Agent: $HTTP_USER_AGENT\r\n");
  fputs( $fp, "Referer: $referer\r\n");
  fputs( $fp, "Content-type: application/x-www-form-urlencoded\r\n" );
  fputs( $fp, "Content-length: " . strlen($data_to_send) . "\r\n" );
  fputs( $fp, "Connection: close\r\n\r\n" );
  fputs( $fp, $data_to_send );

  while( !feof( $fp )) 
  	{
    $cRetVal .= fgets( $fp, 128 );
  	}

  fclose( $fp );
  
	$TempVal=explode("\r\n\r\n",$cRetVal);
	$http_header=$TempVal[0];
	$chunked_content=trim(str_replace($http_header,'',$cRetVal));
	if (stristr($http_header,'Transfer-Encoding: chunked'))
		$cRetVal=Decode_Chunked_Message($chunked_content);
	else
	$cRetVal=$chunked_content;	
  return $cRetVal;
	}

### GET-Request simulieren ######################################################
#
# Diese Funktion holt eine Seite mit GET vom Server.
#
#################################################################################

function GetFromHost( $host, $path, $referer='' ) 
	{
	global $HTTP_USER_AGENT;
	global $HTTP_ACCEPT;
	global $HTTP_ACCEPT_LANGUAGE;
	global $cookie_container;
	global $http_header;
  $cRetVal = "";

  $fp = fsockopen( $host, 80, $errno, $errstr, 30 );
	if (!$fp)
		{
		echo "Host: $host not aviable now!<br>\n";
		echo "Error: $errstr ($errno)<br>\n";
		exit;
		}

	fputs( $fp, "GET $path HTTP/1.1\r\n" );
  fputs( $fp, "Host: $host\r\n" );
  fputs( $fp, "Referer: $referer\r\n");
  fputs( $fp, "Accept: $HTTP_ACCEPT\r\n");
  fputs( $fp, "Accept-Language: $HTTP_ACCEPT_LANGUAGE\r\n");
  fputs( $fp, "User-Agent: $HTTP_USER_AGENT\r\n");
  if ($cookie = $cookie_container->send_cookie())
  	{
  	fputs( $fp, $cookie );  
  	}  
  fputs( $fp, "Connection: close\r\n\r\n" );
  
  while( !feof( $fp )) 
  	{
    $cRetVal .= fgets( $fp, 128 );
  	}

  fclose( $fp );
	
	$TempVal=explode("\r\n\r\n",$cRetVal);
	$http_header=$TempVal[0];
	$chunked_content=trim(str_replace($http_header,'',$cRetVal));
	if (!stristr($http_header, 'Content-Type: text/html'))
		{
		header('Location: http://'.$host.$path);
		exit;
		}
	if (stristr($http_header,'Transfer-Encoding: chunked'))
		$cRetVal=Decode_Chunked_Message($chunked_content);
	else
		$cRetVal=$chunked_content;
	
  return $cRetVal;
	}

### Vorbereitung eines Strings fr die RegEx-Suche ##############################
#
# Diese Funktion macht ein bichen "mehr" als stripslashes();
#
#################################################################################

function clear_reg (&$wert)
	{
	$wert = str_replace('\\','\\\\',$wert);
	$wert = str_replace('[','\[',$wert);
	$wert = str_replace(']','\]',$wert);
	$wert = str_replace('+','\+',$wert);
	$wert = str_replace('.','\.',$wert);
	$wert = str_replace('/','\/',$wert);
	$wert = str_replace('"','\"',$wert);
	$wert = str_replace('?','\?',$wert);
	$wert = str_replace('(','\(',$wert);
	$wert = str_replace(')','\)',$wert);
	$wert = str_replace('=','\=',$wert);
	$wert = str_replace('*','\*',$wert);
	$wert = str_replace('$','\$',$wert);
	$wert = str_replace('&','\&',$wert);
	$wert = str_replace(';','\;',$wert);
	$wert = str_replace('#','\#',$wert);
	}

### Ersetzen der Blcke #########################################################
#
# Hier werden die in der Konfigurationsdatei definierten Blcke ersetzt.
#
#################################################################################

function replace_content_blocks(&$content)
	{
	global $url;
	global $location;	
	
	$RetVal ='';
	
	# Pfad checken
	if (isset($location) AND isset($url['path']))
		{
		for ($i = 0; $i < count ($location); $i++)
			{
			$toCheck = $url['host'].$url['path'];
			if (stristr($toCheck, $location[$i]['value']))
				{
				if (isset($location[$i]['search_block_start']))
					{
					$status = 'search';
					$current_rep = '';
					$search_block_count = count ($location[$i]['search_block_start']);
					$temp_content = explode ("\n", $content);

					# Content-Datei scannen
					foreach ($temp_content as $line)
						{
						if ($status == 'search')
							{
							for ($j=0; $j < $search_block_count; $j++)
								{
								if (stristr($line,$location[$i]['search_block_start'][$j]))
									{
									$status = 'remove';
									$current_rep = $j;
									$RetVal = $RetVal.substr($line,0, strpos($line,$location[$i]['search_block_start'][$j]));
									break 1;
									}
								}
							if ($status != 'remove')
								$RetVal = $RetVal.$line;
							}
							
						if ($status == 'remove')
							{
							if (stristr($line, $location[$i]['search_block_stop'][$current_rep]))
								{
								# Datei?
								if (isset ($location[$i]['replace_block_file'][$current_rep]))
									{
									$insert = implode("",file($location[$i]['replace_block_file'][$current_rep]));
									$RetVal = $RetVal.$insert.substr($line,strpos($line,$location[$i]['search_block_stop'][$current_rep])+strlen($location[$i]['search_block_stop'][$current_rep]));
									$current_rep='';
									$status = 'search';
									}
								else if (isset ($location[$i]['replace_block_line'][$current_rep]))
									{
									$RetVal = $RetVal.$location[$i]['replace_block_line'][$current_rep].substr($line,strpos($line,$location[$i]['search_block_stop'][$current_rep])+strlen($location[$i]['search_block_stop'][$current_rep]));
									$current_rep='';
									$status = 'search';									
									}
								else
									{
									echo "Fehler beim Ersetzen von $location[$i]['search_block_start'][$current_rep]";
									exit;
									}
								}
							}
						}
					$content=$RetVal;	
					}
				}

			}
		}
	
	return;
	}

### Suchbegriffe ersetzen #######################################################

function replace_content(&$content)
	{
	global $url;
	global $location;	
	
	$trenner = '[\040|\n|\t|\r]*';
	
	# Pfad checken
	if (isset($location) AND isset($url['path']))
		{
		for ($i = 0; $i < count ($location); $i++)
			{
			$toCheck = $url['host'].$url['path'];
			if (stristr($toCheck, $location[$i]['value']))
				{
				if (isset($location[$i]['search']))
					{
					for ($j = 0; $j < count($location[$i]['search']); $j++)
						{
						$search = $location[$i]['search'][$j];
						clear_reg ($search);
						$search = "/".$search."/i";
						$replace = $location[$i]['replace'][$j];
						$content = preg_replace($search, $replace, $content);
						}
					}	
				}

			}
		}
	return;
	}
	
### berprfen, ob ein Link ersetzt werden soll #################################
		
function check_link($link)
	{
	global $location;
	
	$url = parse_url ($link);
	
	# Pfad checken
	if (isset($location) AND isset($url['path']))
		{
		for ($i = 0; $i < count ($location); $i++)
			{
			$toCheck = $url['host'].$url['path'];
			if (stristr($toCheck, $location[$i]['value']))
				return true;
			}
		}		
	return false;
	}

### Aufbau des neuen Links ######################################################

function make_link ($link, $base_url)
	{
	global $url;
	global $path;
	global $PHP_SELF;
	global $SERVER_NAME;
	global $DEFAULTS;
	
	if(isset($DEFAULTS))
		$new_server = 'http://'.$SERVER_NAME.$PHP_SELF.'?&webgrab_path=';
	else
		$new_server = 'http://'.$SERVER_NAME.$PHP_SELF.'?webgrab_path=';
		
	$set = FALSE;
	
	if (strstr($link,'webgrab')) return $link;
	if (trim($link) == '') return;
	if (strtoupper(trim(substr($link,0,11))) == 'JAVASCRIPT:') return $link;

	if (strtoupper(substr($link,0,4)) == 'HTTP')
		{
		if (stristr($link, 'mailto:')) return $link;
		$new_url = $link;
		
		if (check_link($new_url) == true)
			return $new_server.$new_url;
		else
			return $link;
		}

	if ($link[0] == '/')
		{
		if ($base_url)
			$new_url = $base_url.$link;
		else
			$new_url = 'http://'.$url['host'].$link;

		if (check_link($new_url) == true)
			return $new_server.$new_url;
		else
			return $new_url;
		}
		
	if ($link[0] == '#')
		{
		$togo = $path;
		if ($base_url)
			$new_url = $base_url.$togo.$link;
		else
			{
			if ($togo[0] != '/') $togo = '/'.$togo;
			$new_url = 'http://'.$url['host'].$togo.$link;
			}
		if (check_link($new_url) == true)
			return $new_server.$new_url;
		else
			return $new_url;
		}

	if (strtoupper(substr($link,0,4)) != 'HTTP')
		{
		if (stristr($link, 'mailto:')) return $link;
		if (stristr($link, 'javascript:')) return $link;

		if (stristr(basename($path), '.') OR stristr(basename($path), '?'))
			$togo = dirname($path).'/';
		else
			$togo = $path;
				
		if ($base_url)
			$new_url = $base_url.$link;
		else
			{
			if ($togo[0] != '/') $togo = '/'.$togo;
			$new_url = 'http://'.$url['host'].$togo.$link;
			}
		if (check_link($new_url) == true)
			return $new_server.$new_url;
		else
			return $new_url;

		}	
	return $link;
	}

### Grafiklinks werden anders behandelt als hrefs ###############################

function make_graphic_link ($link,$base_url)
	{
	global $url;
	global $path;
	global $PHP_SELF;
	global $SERVER_NAME;
	
	if (stristr($link,'http://'.$url['host'])) return $link;
	if (strstr($link,'webgrab')) return $link;
	if (trim($link) == '') return $link;

	if ($link[0] == '/')
		{
		if ($base_url)
			$new_url = $base_url.$link;
		else
			$new_url = 'http://'.$url['host'].$link;

		return $new_url;
		}
	
	if (strtoupper(substr($link,0,4)) != 'HTTP')
		{
		if (stristr(basename($path), '.') OR stristr(basename($path), '?'))
			$togo = dirname($path).'/';
		else
			$togo = $path;
		if ($base_url)
			$new_url = $base_url.$togo.$link;
		else
			{
			if ($togo[0] != '/') $togo = '/'.$togo;
			$new_url = 'http://'.$url['host'].$togo.$link;
			}
		return $new_url;
		}
		
	return $link;
	}	
	
### Bug mit Slashes fixen #######################################################
#
# Daran habe ich lange gearbeitet. Es sieht so aus, als wre das ein Bug in der
# RegEx-Implementierung von PHP. Bei einem gefundenen Wert werden vor Slashes
# weitere Slashes gesetzt. Kommen in einem Wert mehrere Slashes vor, wird beim
# letzten vorkommen nichts mehr vorangesetzt. Diese Funktion korrigiert diesen
# Bug.
#
#################################################################################

function corr_slashes_bug($value)
	{	
	if (stristr($value,'\\\\"'))
		{
		$value=str_replace ('\\\\"','#t#',$value);
		$value=str_replace ('\\"','\\\\"',$value);
		$value=str_replace ('#t#','\\\\"',$value);
		}
	$value = stripslashes($value);
	return $value;
	}
	
### Links ersetzen ##############################################################
#
# Ich habe mit vielen Seiten getestet, gehe aber davon aus, dass in Zukunft
# noch einige nderungen an dieser Funktion erforderlich sein werden.
#
#################################################################################

function replace_url($content)
	{
	global $url;
	global $base_url;
	global $path;
	global $PHP_SELF;
	global $SERVER_NAME;
	global $DEFAULTS;
	
	if(isset($DEFAULTS))
		$new_server = 'http://'.$SERVER_NAME.$PHP_SELF.'?&webgrab_path=';
	else
		$new_server = 'http://'.$SERVER_NAME.$PHP_SELF.'?webgrab_path=';
		
	$self_path = 'http://'.$SERVER_NAME.$PHP_SELF;	
	$trenner = '[\040|\n|\t|\r]*';
	
	# Base-href sichern
	unset($base_url);
	preg_match_all("/base".$trenner."href".$trenner."=".$trenner."[\"|\']?([^\'|\"|>|\040]+)[\'|\"|>|\040]{1}/i", $content, $ArrayOfLinks);
	if (isset($ArrayOfLinks[1][0]))
		{
		$base_url = $ArrayOfLinks[1][0];
		}
	else
		$base_url = false;
	
	# hrefs behandeln
	$search = "/<".$trenner."(a|link)([^>]+)href".$trenner."=".$trenner."([\"|\'|\\\\]*)([^\'|\"|>|\040]*)([\"|\'|>|\040|\\\\]*)/ie";
	$replace = "'<'.stripslashes('\\1\\2href = \\3').make_link('\\4','$base_url').stripslashes('\\5').''";
	$content = preg_replace($search, $replace, $content);

	# .hrefs behandeln
	$search = "/\.href".$trenner."=".$trenner."\'([^\']*)\'/ie";
	$replace = "'.href=\''.make_link('\\1','$base_url').'\''";
	$content = preg_replace($search, $replace, $content);

	# metaangaben	                                                 
	$search = "/content".$trenner."=".$trenner."([\"|\'])?([^\;]*);".$trenner."URL".$trenner."=".$trenner."([^\"|\'|>|\040]+)/ie";
	$replace = "\"content=\\1\\2; URL=\".make_link('\\3','$base_url').\"\\4\"";
	$content = preg_replace($search, $replace, $content);
	
	# location replace ersetzen
	$search = "/location\.replace".$trenner."\(".$trenner."([\'|\"])?([^\'|\"]*)([\'|\"])?".$trenner."\)/ie";
	$replace = "'location.replace ('.stripslashes('\\1').make_link('\\2','$base_url').stripslashes('\\3').')'";
	$content = preg_replace($search, $replace, $content);	
	
	# forms
	unset($ArrayOfLinks);
	preg_match_all("/(<".$trenner."form[^>]*>)/i", $content, $ArrayOfLinks);
	$links = array_unique ($ArrayOfLinks[1]);
	
	while (list(,$link) = each($links))
		{
		$set = FALSE;
		if (strstr($link,'webgrab')) continue;
		if (trim($link) == '') continue;
		
		if (preg_match("/action".$trenner."=".$trenner."([\"|\'])?([^\"|\'|\040|>]*)([\"|\'])?/i", $link, $matches))
			{
			$link = $matches[2];
			$action = $matches[2];
			if (trim($action)=="")
				{
				$togo = $path;
				if ($togo[0] != '/') $togo = '/'.$togo[0];
				$action = 'http://'.$url['host'].$togo.$action;				
				}
			if (stristr($action,$url['domain']) AND strtoupper(substr($action,0,4)) == 'HTTP')
				{
				if (stristr($action, 'mailto:')) continue;
				}
			else if ($action[0] == '/')
				{
				$action = 'http://'.$url['host'].$action;
				}
			else if (strtoupper(substr($action,0,4)) != 'HTTP')
				{
				if (stristr($action, 'mailto:')) continue;
				if (stristr(basename($path), '.') OR stristr(basename($path), '?'))
					$togo = dirname($path).'/';
				else
					$togo = $path;
				if ($togo[0] != '/') $togo = '/'.$togo;
				$action = 'http://'.$url['host'].$togo.$action;
				}
			clear_reg ($link);	
			$search  = array("/<".$trenner."form([^>]*)action".$trenner."=".$trenner."([\"|\'])?".$link."([\"|\'])?".$trenner."([^>]*)>/i");
				if(isset($DEFAULTS))
					$replace = array("<form\\1action = \\2".$self_path."\\3 \\4><input type=hidden name=dummy><input type=\"hidden\" name=\"webgrab_path\" value=\"".$action."\">");
				else
					$replace = array("<form\\1action = \\2".$self_path."\\3 \\4><input type=\"hidden\" name=\"webgrab_path\" value=\"".$action."\">");
			$content = preg_replace($search, $replace, $content);					
			}
		else
			{
			if ($path[0] != '/') $path = '/'.$path;
			$action = 'http://'.$url['host'].$path;
			preg_match("/<".$trenner."form([^>]*)>/i", $link, $matches);
			$toreplace = $matches[1];
			clear_reg ($toreplace);	
			$search  = array("/<".$trenner."form".$toreplace.">/i");
			$replace = array("<form".stripslashes($toreplace)."><input type=\"hidden\" name=\"webgrab_path\" value=\"".$action."\">");
			$content = preg_replace($search, $replace, $content);								
			}
		}	

	# frames
	$search = "/frame([^>]*src".$trenner."=".$trenner."[\"|\'|\\\\]*)([^\'|\"|>|\040]*)([\'|\"|>|\040|\\\\]*)/ie";
	$replace = "'frame'.stripslashes('\\1').make_link('\\2','$base_url').stripslashes('\\3').''";
	$content = preg_replace($search, $replace, $content);

	# Alle verbleibenden Urls ersetzen, in denen die Domne vorkommt,
	# aber nicht webgrab.	
	$domain = $url['domain'];
	clear_reg ($domain);
	$search = "/([\"|\'|\040|\n|\r|\t|\\\\]+)(http:\/\/[a-zA-Z0123456789\.\_]*".$domain."[a-zA-Z0123456789\_\/\.\?\&\=\;\-]*)([\"|\'|\040|\n|\t|\r|>|\\\\]+)/ieS";
	$replace = "''.stripslashes('\\1').make_link('\\2','$base_url').stripslashes('\\3').''";
	$content = preg_replace($search, $replace, $content);

	if (isset($base_url))
		{
		$search = "/base".$trenner."href".$trenner."=".$trenner."([\"|\']{1})?([^\'|\"|>|\040]*)([\'|\"|>|\040]{1})/i";
		$replace = "base href=\\1".$new_server.$base_url."\\3";
		$content = preg_replace($search, $replace, $content);
		}

	# eventuelle fehler bei Formularen zurcktauschen
	$decoded_server = $new_server;
	clear_reg ($decoded_server);
	$content = str_replace('<input type="hidden" name="webgrab_path" value="'.$new_server,'<input type=hidden name=webgrab_path value="',$content);	
								
	# eventuelle fehler bei Grafiken zurcktauschen
	$search  = array("/(img|script|image)([^>]*)".$trenner."src".$trenner."=([\n|\t|\r|\040]*)([\"|\']{1})".$decoded_server."([a-zA-Z0123456789\.\_\?\&\+\-\:\/]*)([\"|\']{1})([>|\040|\n|\r|\t]{1})/i");
	$replace = array("\\1\\2src = \\3\\4\\5\\6\\7");
	$content = preg_replace($search, $replace, $content);

	# eventuelle fehler bei link zurcktauschen
	$search  = array("/(link)([^>]*)href".$trenner."=([\n|\t|\r|\040]*)([\"|\']{1})".$decoded_server."([a-zA-Z0123456789\.\_\?\&\+\-\:\/]*)([\"|\']{1})([>|\040|\n|\r|\t]{1})/i");
	$replace = array("\\1\\2href = \\3\\4\\5\\6\\7");
	$content = preg_replace($search, $replace, $content);
	 
	# grafiken tauschen
	$search = "/<".$trenner."(img|script|image)([^>]*".$trenner."src[\040|\n|\t|\r|\\\\]*=[\n|\t|\r|\040|\"|\'|\\\\]*)([^\"|>|\040|\|\\\\']*)([^>]*>)/ieS";
	$replace = "'<'.stripslashes('\\1\\2').make_graphic_link('\\3','$base_url').corr_slashes_bug('\\4').''";
	$content = preg_replace($search, $replace, $content);

	# button-grafiken tauschen
	$search = "/<".$trenner."input".$trenner."([^>]*src".$trenner."=[\n|\t|\r|\040|\"|\'|\\\\]*)([^\"|>|\040|\']*)([\"|>|\040|\n|\r|\t|\'|\\\\]{1})/ie";
	$replace = "'<input '.stripslashes('\\1').make_graphic_link('\\2','$base_url').stripslashes('\\3').''";
	$content = preg_replace($search, $replace, $content);
	
	# javascript grafiken tauschen
	$search = "/\.src".$trenner."=[\t|\040]*([\"|\']){1}([^\'|\n|\"|\r|\.]+\.[A-Za-z0-9]+)([\"|\']){1}/ie";
	$replace = "'.src='.stripslashes('\\1').make_graphic_link('\\2','$base_url').stripslashes('\\3').''";
	$content = preg_replace($search, $replace, $content);
	
	# background-images tauschen background="/gfx/bottom_15.jpg" 
	$search = "/(background".$trenner."=[\n|\t|\r|\040|\"|\']*)([^\"|>|\040|\']*)([\"|>|\040|\n|\r|\t|\'\/]{1})/ie";
	$replace = "''.stripslashes('\\1').make_graphic_link('\\2','$base_url').stripslashes('\\3').''";
	$content = preg_replace($search, $replace, $content);

	# eventuelle fehler bei Backgrounds zurcktauschen
	$search  = array("/background".$trenner."=([\n|\t|\r|\040]*)([\"|\']{1})?".$decoded_server."([a-zA-Z0123456789\.\_\?\&\+\-\:]*)([\"|\']{1})?([>|\040|\n|\r|\t]{1})/i");
	$replace = array("background = \\1\\2\\3\\4\\5");
	$content = preg_replace($search, $replace, $content);	

	return $content;
	}

### Formularbehandlung im Stealth-Mode ##########################################
#
# Im Stealth-Mode werden keine Links ersetzt, da diese Arbeit von der 
# Rewrite-Engine vom Apache erledigt wird. Bei Formularen ist es aber dennoch
# erforderlich.
#
#################################################################################

function replace_forms($content)
	{
	global $url;
	global $SERVER_NAME;
	global $PHP_SELF;
	global $path;
	
	$self_path = 'http://'.$SERVER_NAME.$PHP_SELF;	
	$trenner = '[\040|\n|\t|\r]*';	
	
		
	preg_match_all("/(<".$trenner."form[^>]*>)/i", $content, $ArrayOfLinks);
	$links = array_unique ($ArrayOfLinks[1]);
	
	while (list(,$link) = each($links))
		{
		$set = FALSE;
		if (strstr($link,'webgrab')) continue;
		if (trim($link) == '') continue;
		
		if (preg_match("/action".$trenner."=".$trenner."([\"|\'])?([^\"|\'|\040|>]*)([\"|\'])?/i", $link, $matches))
			{
			$link = $matches[2];
			$action = $matches[2];
			
			if (trim($action)=="")
				{
				//$action = ''.$url['host'].$togo.$action;
				$action = 'http://'.$SERVER_NAME.$togo.$action;
				}
			if (stristr($action,$url['domain']) AND strtoupper(substr($action,0,4)) == 'HTTP')
				{
				if (stristr($action, 'mailto:')) continue;
				
				$local_path=substr($action,7);
				$local_path=substr($local_path, strpos($local_path, '/'));
				
				$action = 'http://'.$SERVER_NAME.$local_path;				
				}
			else if ($action[0] == '/')
				{
				//$action = 'http://'.$url['host'].$action;
				$action = 'http://'.$SERVER_NAME.$action;
				}
			else if (strtoupper(substr($action,0,4)) != 'HTTP')
				{
				if (stristr($action, 'mailto:')) continue;
				if (stristr(basename($path), '.') OR stristr(basename($path), '?'))
					$togo = dirname($path).'/';
				else
					$togo = $path;
				if ($togo[0] != '/') $togo = '/'.$togo;
				//$action = 'http://'.$url['host'].$togo.$action;
				$action = 'http://'.$SERVER_NAME.$togo.$action;
				}
			//echo $action;		
			
			clear_reg ($link);	
			$search  = array("/<".$trenner."form([^>]*)action".$trenner."=".$trenner."([\"|\'])?".$link."([\"|\'])?".$trenner."([^>]*)>/i");
			$replace = array("<form\\1action = \\2".$action."\\3 \\4>");
			$content = preg_replace($search, $replace, $content);
			
			}
		}	
	return $content;
	}

#################################################################################
### Start der Hauptroutine ######################################################
#################################################################################

$cookie_container = new cookie_container;
$content='';

while (!isset($http_header) OR stristr($http_header, 'Location'))
	{
	# HTTP-Variablen importieren
	if(isset($HTTP_REFERER))
		$referer = substr($HTTP_REFERER,strpos($HTTP_REFERER,'webgrab_path=')+13);
	else
		$referer = '';
	
	unset ($url);
	unset ($http_header);
	
	if (isset($HTTP_POST_VARS) AND count($HTTP_POST_VARS)>0)
			{
			//echo $REQUEST_URI;
			if (isset($HTTP_POST_VARS['webgrab_path']))
				$webgrab_path = urldecode($HTTP_POST_VARS['webgrab_path']);
			else
				$webgrab_path = 'http://'.$SERVER_NAME.$REQUEST_URI;
				
			preg_match_all("/http\:\/\/([^\?|\&|\/]*)/i", $webgrab_path, $temp);
				$url['host'] = $temp[1][0];
			preg_match_all("/([a-zA-Z1234567890]+.[a-zA-Z1234567890]+)\/?$/i", $url['host'], $temp);
			$url['domain'] = $temp[1][0];
	
			preg_match_all("/http\:\/\/[^\?|\&|\/]*(\/[^\?|\&]*)/i", $webgrab_path, $temp);
			if (isset($temp[1][0]))
				$url['path'] = $temp[1][0];
			else
				$url['path'] = '/';
				
			preg_match_all("/http\:\/\/[^\?]*\?(.*)/i", $webgrab_path, $temp);
			if (isset($temp[1][0]))
				{
				$url['query'] = $temp[1][0];
				if ($url['query'][0] == '&')
					$url['query'] = substr($url['query'],1);
				$url['query']='?'.$url['query'];
				}
	
			reset($HTTP_POST_VARS);
			
			$parms = '';
			while (list($k, $v) = each ($HTTP_POST_VARS))
				{
				if ($k == 'webgrab_path') continue;
				if (is_array($v))
					{
					while (list($sk, $sv) = each ($v))
						{
						if (strstr($sv,'&')) $sv=str_replace('&','%26',$sv);
						if (strstr($sv,'?')) $sv=str_replace('?','%3F',$sv);
						$parms.='&'.$k.'['.$sk.']='.stripslashes($sv);
						}
					}
				else
					{
					if (strstr($v,'&')) $v=str_replace('&','%26',$v);
					if (strstr($v,'?')) $v=str_replace('?','%3F',$v);
					$parms.='&'.$k.'='.stripslashes($v);
					}
				}
			if (strtoupper(substr($url['path'],-4)) != '.HTM')
				$parms = substr($parms, 1);
			$webgrab_action = 'POST';
		}	
	else if (isset($HTTP_GET_VARS['webgrab_path']) OR isset($continue_more))
		{
		$temp_path = urldecode($QUERY_STRING);
		$temp_path = substr($temp_path,13 );
		
		if (isset($continue_more))
			$webgrab_path = $continue_more;
		else if (strlen(trim($temp_path)) == 0)
			$webgrab_path = urldecode($HTTP_GET_VARS['webgrab_path']);
		else
			$webgrab_path = $temp_path;
			
		preg_match_all("/http\:\/\/([^\?|\&|\/]*)/i", $webgrab_path, $temp);
		$url['host'] = $temp[1][0];

		preg_match_all("/([a-zA-Z1234567890]+.[a-zA-Z1234567890]+)\/?$/i", $url['host'], $temp);
		$url['domain'] = $temp[1][0];

		preg_match_all("/http\:\/\/[^\?|\&|\/]*(\/[^\?|\&]*)/i", $webgrab_path, $temp);
		if (isset($temp[1][0]))
			$url['path'] = $temp[1][0];
		else
			$url['path'] = '/';
			
		preg_match_all("/http\:\/\/[^\?|\&]*[\?|\&]{1}(.*)/i", $webgrab_path, $temp);
		if (isset($temp[1][0]))
			{
			$url['query'] = $temp[1][0];
			if ($url['query'][0] == '&' AND strtoupper(substr($url['path'],-4)) != '.HTM')
				$url['query'] = substr($url['query'],1);
			$url['query']='?'.$url['query'];
			}
		$webgrab_action = 'GET';
	
		}
	else
		{
		$webgrab_path = $webgrab_no_path;
		
		preg_match_all("/http\:\/\/([^\?|\&|\/]*)/i", $webgrab_path, $temp);
		$url['host'] = $temp[1][0];

		preg_match_all("/([a-zA-Z1234567890]+.[a-zA-Z1234567890]+)\/?$/i", $url['host'], $temp);
		$url['domain'] = $temp[1][0];

		preg_match_all("/http\:\/\/[^\?|\&|\/]*(\/[^\?|\&]*)/i", $webgrab_path, $temp);
		if (isset($temp[1][0]))
			$url['path'] = $temp[1][0];
		else
			$url['path'] = '/';
			
		preg_match_all("/http\:\/\/[^\?|\&]*[\?|\&]{1}(.*)/i", $webgrab_path, $temp);
		if (isset($temp[1][0]))
			{
			$url['query'] = $temp[1][0];
			if ($url['query'][0] == '&' AND strtoupper(substr($url['path'],-4)) != '.HTM')
				$url['query'] = substr($url['query'],1);
			$url['query']='?'.$url['query'];
			}
		$webgrab_action = 'GET';
		}
	
	$path = $url['path'];
	
	if(isset($url['query']) AND strlen($url['query'])>1)
		$path = $path.$url['query'];
	
	unset($content);
	unset($http_header);
	
	if ($webgrab_action == 'GET')
		$content = GetFromHost( $url['host'], $path, $referer );
	else
		$content = PostToHost( $url['host'], $path, $parms, $referer );

	$all_headers = explode("\r\n",$http_header);
	foreach ($all_headers as $this_header)
		{
		if (stristr($this_header, 'Set-Cookie'))
			{
			$cookie = substr($this_header, strpos(strtoupper($this_header), 'SET-COOKIE:')+11);
			$cookie_container->put_cookie($cookie);
			}
		}

	if (stristr($http_header, 'Location'))
		{
		
		$new_url = substr($http_header, strpos(strtoupper($http_header), 'LOCATION:')+9);
		if (strstr($new_url, "\n"))
			$new_url = substr($new_url, 0, strpos($new_url, "\n"));
		else if (strstr($new_url, "\r"))
			$new_url = substr($new_url, 0, strpos($new_url, "\r"));
		else
			$new_url = trim($new_url);
			
		$webgrab_path = urldecode(trim($new_url));

		unset ($HTTP_GET_VARS);
		unset ($HTTP_POST_VARS);
		$continue_more = $webgrab_path;
		if (!stristr($continue_more, 'HTTP'))
			{
			if ($continue_more[0] != '/')
				{
				if (stristr(basename($path), '.') OR stristr(basename($path), '?'))
					$togo = dirname($path).'/';
				else
					$togo = $path;
				if ($togo[0] != '/') $togo = '/'.$togo;
				$continue_more = 'http://'.$url['host'].$togo.$continue_more;
				}
			else
				$continue_more = 'http://'.$url['host'].$continue_more;
			}
		
		}
	}
	
if (!isset($webgrab_stealth) OR	$webgrab_stealth=='off')
	$content = replace_url($content);
else
	$content = replace_forms($content);
	
$cookie_container->save();
replace_content_blocks($content);
replace_content($content);

foreach ($all_headers as $this_header)
	{
	
	if (stristr($this_header, 'Expires'))
		header($this_header."\r\n");
		
	if (stristr($this_header, 'Cache-Control'))
		header($this_header."\r\n");

	if (stristr($this_header, 'Content-Length')) 
		{
		header("Content-Length: ".strlen(trim($content))."\r\n");
		}
	}
echo trim($content);
?>